#ifndef DISPLAY_H
#define DISPLAY_H

#include "mbed.h"

void display_init(void);
void display_box(uint16_t x, uint16_t y, uint16_t w, uint16_t h, uint16_t color);
void display_clear(uint16_t color);
void display_send_command(uint16_t command, uint8_t finish);
void display_send_data(uint16_t data, uint8_t finish);
void display_setwindow(uint16_t x, uint16_t y, uint16_t w, uint16_t h);
void display_image(uint16_t x, uint16_t y, uint16_t w, uint16_t h, uint16_t *data);
uint16_t display_RGB2color(uint8_t r,uint8_t g,uint8_t b);
void display_zoomedRGBimage(uint16_t x, uint16_t y, uint16_t w, uint16_t h, uint16_t z, uint8_t *data);
void display_zoomedblendedRGBimage(uint16_t x, uint16_t y, uint16_t w, uint16_t h, uint16_t z, uint8_t *data, uint8_t r1, uint8_t g1, uint8_t b1, uint8_t r2, uint8_t g2, uint8_t b2);
void display_indexedimage(uint16_t x, uint16_t y, uint16_t w, uint16_t h, uint8_t *data, uint16_t *palette);
void display_fullscreencameraimage(uint8_t *data, uint16_t *palette);
void display_halfscreencameraimage(uint16_t x, uint16_t y, uint8_t *data, uint16_t *palette);
void display_cameraimage(uint16_t x, uint16_t y, uint16_t w, uint16_t h, uint8_t *data, uint16_t *palette);
void display_camerahalfimage(uint16_t x, uint16_t y, uint16_t w, uint16_t h, uint8_t *data, uint16_t *palette);
void display_rleimage(uint16_t x, uint16_t y, uint16_t w, uint16_t h, uint8_t *data, uint16_t *palette);
uint8_t display_locatecharacter(char c);
void display_zoomedRGBtext(uint16_t midx, uint16_t midy, uint16_t z, uint16_t incx, uint16_t incy, char * text, uint8_t r1, uint8_t g1, uint8_t b1, uint8_t r2, uint8_t g2, uint8_t b2);

#endif