#include "mbed.h"

#include "fun2016.h"
#include "system.h"
#include "display.h"
#include "camera.h"
#include "gsm.h"
#include "touch.h"
#include "phone.h"
#include "canvas.h"
#include "acc.h"



void init(void);

MODSERIAL debug(P0_2, P0_3); // ISP connection to PC

unsigned char db[16];
int dbcount=0;
uint16_t i2cdata[16];


int main()
   {
   int i, counter=0;
   
   wait_ms(1000); // wait for subsystems to power up
   system_init();
   if (system_debugpin()) gsm_flash(); // upgrade the affixed SIM900D firmware - this function will not return, so you have to re-reset the phone afterwards
   
   init();
   debug.printf("Hello, cool world!\n"); // check communications to the PC

   while (1)
      {
      // some kind of master loop timer would be nice if you want to add animations...
      canvas_update();
      phone_update();
      gsm_update();
      acc_measure();
      while (debug.readable()) gsm.putc(debug.getc());
      wait_ms(20);    
      }      
   }



void init(void)
   {  
   // set MBED controlled UARTs
   debug.baud(230400);
   gsm.baud(9600);
   // init subsystems - lower levels of hierarchy first
   display_init();
   camera_init();
   gsm_init();
   touch_init();
   phone_init();
   canvas_init();
   acc_init();
   }
   
   