#include "mbed.h"
#include "system.h"
#include "gsm.h"
#include "phone.h"

// this intermediate layer isolates the UI from the module and also
// buffers the requests... or currently only the latest one
// for superhuman user speed this requires some priorization



long phone_state=0,phone_request_call,phone_request_sendMMS,phone_request_hangup,phone_request_answer;
char phone_number[16];



void phone_init(void)
   {
   gsm_ringing=0;
   gsm_hangup=0;
   }



void phone_update(void)
   {
   if (gsm_insisting==0) // gsm is now free for suggestions
      {
      if (phone_request_hangup)
         {
         phone_request_hangup=0;
         gsm_endcall();
         }
      else if (phone_request_answer)
         {
         phone_request_answer=0;
         gsm_acceptcall();
         }
      else if (phone_request_call)
         {
         phone_request_call=0;
         gsm_makecall(phone_number);
         }
      else if (phone_request_sendMMS)
         {
         phone_request_sendMMS=0;
         gsm_sendMMS(phone_number);
         }
      }
   }



void phone_answer(void)
   {
   phone_request_answer=1;
   }
   
   
      
void phone_call(char *number)
   {
   strcpy(phone_number,number);
   phone_request_call=1;
   phone_request_sendMMS=0; // forget the pending request
   }


   
void phone_sendMMS(char *number)
   {
   strcpy(phone_number,number);
   phone_request_sendMMS=1;
   phone_request_call=0; // forget the pending request
   }


   
void phone_hangup(void)
   {
   phone_request_hangup=1;
   }


   
int phone_ringing(void)
   {
   if ((gsm_ringing)&&(GETIO(GSM_RI)==0)) return 1;
   gsm_ringing=0; // clear dangling ring (which could come late from the buffer?)
   return 0;
   }
   
   
   
int phone_ready(void)
   {
   return (gsm_online);
   }



int phone_live(void)
   {
   return (!gsm_hangup);
   }   
   


int phone_pinready(void)
   {
   if (gsm_waitingforpin) return(2);
   return(gsm_pinready);
   }



void phone_setpin(char *pin)
   {
   strncpy(gsm_pin,pin,4);
   gsm_pin[4]=0;
   gsm_pinready=1;
   }


   