#ifndef SYSTEM_H
#define SYSTEM_H

#include "mbed.h"

#define CLRIO2(PORTNO,PINNO) (LPC_GPIO##PORTNO)->FIOCLR=(1<<PINNO)
#define SETIO2(PORTNO,PINNO) (LPC_GPIO##PORTNO)->FIOSET=(1<<PINNO)
#define GETIO2(PORTNO,PINNO) ((((LPC_GPIO##PORTNO)->FIOPIN)>>PINNO)&1)
#define INIO2(PORTNO,PINNO) (((LPC_GPIO##PORTNO)->FIODIR)&=~(1<<PINNO))
#define OUTIO2(PORTNO,PINNO) (((LPC_GPIO##PORTNO)->FIODIR)|=(1<<PINNO))

#define CLRIO(x) CLRIO2(x)
#define SETIO(x) SETIO2(x)
#define GETIO(x) GETIO2(x)
#define INIO(x) INIO2(x)
#define OUTIO(x) OUTIO2(x)

#define LIMIT(x,min,max) ((x<min) ? min : (x>max) ? max : x)

void system_init(void);
void system_configurepin(long port, long bit, long function, long mode, long direction, long value);
void system_setbit(volatile std::uint32_t *address, long index, long value);
void system_setbitpair(volatile std::uint32_t *address, long index, long value);
uint8_t system_debugpin(void);
void system_setled(uint8_t value);

#endif